﻿using System;
using System.Collections.Generic;
using System.Text;

using System.IO;
using System.Text.RegularExpressions;

namespace Xenon.CopyfileRenamer
{
    class Program
    {
        static void Main(string[] args)
        {
            //----------------------------------------
            // 元のファイル名
            //----------------------------------------
            string nameSrc = "";

            if (1 <= args.Length)
            {
                nameSrc = args[0];
            }
            else
            {
                goto gt_error1;
            }



            //----------------------------------------
            // ファイル名と拡張子に分けます。
            //----------------------------------------
            string name;
            string extensionWithDot;
            int dot = nameSrc.LastIndexOf(".");
            if (1 <= dot)
            {
                name = nameSrc.Substring(0, dot);
                extensionWithDot = nameSrc.Substring(dot);
            }
            else
            {
                name = nameSrc;
                extensionWithDot = "";
            }


            //----------------------------------------
            // ファイル名の頭から「コピー ～ 」「コピー (1) ～ 」等を削除します(WindowsXP対応)
            //----------------------------------------
            name = Regex.Replace(name, "(コピー ～ |コピー [(]\\d+[)] ～ )", "");
            // 先頭の指定「^」が利きませんでした。



            StringBuilder sb = new StringBuilder();

            sb.Append(name);


            // ファイルの更新日付を取得
            DateTime dtUpdate = System.IO.File.GetLastWriteTime(nameSrc);
            sb.Append(dtUpdate.ToString("(yyyy年MM月dd日 HH時mm分ss秒)"));

            // 今日の日付
            //sb.Append(DateTime.Now.ToString("(yyyy年MM月dd日 HH時mm分ss秒)"));

            sb.Append(extensionWithDot);


            //----------------------------------------
            // 新しいファイル名
            //----------------------------------------
            string nameDst = sb.ToString();

            // リネーム
            File.Move(nameSrc, nameDst);


            goto gt_end;

        gt_error1:
            System.Console.WriteLine("ファイルをアイコンへドラッグ＆ドロップしてください。");
            System.Console.ReadKey();

        gt_end:
            ;
        }
    }
}
